/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui.components;

import tools.*;

import javax.swing.*;
import java.awt.*;
import java.awt.Event.*;
import java.awt.event.*;
import java.io.*;
import java.lang.reflect.InvocationTargetException;
import java.util.regex.*;
import main.PhysMo;


/**
 * 
 *
 * @author jasonkb
 */
public class FirstScreen extends JPanel implements ActionListener, WindowListener, Runnable
{
    public JButton newProject;
    public JButton existingProject;
    public JButton howtoUse;
    public JButton aboutPhysmo;
    public JFrame f;
    public FFmpegIO ffmpeg;
    public JProgressBar pb;
    
    public JFileChooser videoSelect;
    public JFileChooser workingDirectorySelect;
    public AnalysisWindow projectWindow;
    
    
    public FirstScreen(JFrame frame)
    {
        pb = new JProgressBar(JProgressBar.HORIZONTAL, 0, 10);
        ffmpeg = new FFmpegIO(pb);
        f= frame;
        f.addWindowListener(this);
        this.setLayout(new FlowLayout());
        newProject = new JButton("Open Video");
        existingProject = new JButton("Open Project");
        aboutPhysmo = new JButton("About PhysMo");
        howtoUse = new JButton("Instructions");
        
        this.add(newProject);
        //this.add(existingProject);
        this.add(aboutPhysmo);
        this.add(howtoUse);
        
        
        
        
        this.add(pb);
        
        //pb.setVisible(false);
        
        newProject.addActionListener(this);
        aboutPhysmo.addActionListener(this);
        f.pack();
    }
    
    public void actionPerformed(ActionEvent e)
    {
        
        
        if(e.getSource() == newProject)
        {
            
            videoSelect = new JFileChooser(PhysMo.lastVideoDirectory);
            videoSelect.setFileFilter(new MovieFileFilter());
            videoSelect.setFileView(new MovieFileView());
            videoSelect.setAcceptAllFileFilterUsed(false);
            videoSelect.setDialogTitle("Open a video file...");
            
            int retval = videoSelect.showOpenDialog(null);
            if (retval == JFileChooser.APPROVE_OPTION) 
            {
                //... The user selected a file, get it, use it.
                File file = videoSelect.getSelectedFile();
                PhysMo.lastVideoDirectory = file.getParent();
                
                
                //... Update user interface.
                f.setTitle("PhysMo v2.0 - "+file.getName());
                PhysMo.videoName = file.getName();
                PhysMo.videoPath = file.getAbsolutePath();
                
                //parse the video information
                double[] videoProperties = ffmpeg.getProperties(PhysMo.videoPath);
                PhysMo.duration = videoProperties[0];
                PhysMo.fps = videoProperties[1];
                f.repaint();
                //select working directory
                
                try
                {
                workingDirectorySelect = new JFileChooser(PhysMo.lastWorkingDirectory);
                workingDirectorySelect.setDialogTitle("Create a directory to work in...");
                workingDirectorySelect.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
            
                retval = workingDirectorySelect.showOpenDialog(null); 
                if (retval == JFileChooser.APPROVE_OPTION) 
                {
                    //... The user selected a file, get it, use it.
                    file = workingDirectorySelect.getSelectedFile();
                    //... Update user interface.
                    PhysMo.workingDirectory = file.getAbsolutePath();
                    PhysMo.lastWorkingDirectory = file.getAbsolutePath();
                
               
                
                
                
                    newProject.setEnabled(false);
                
                    
                    FileWriter outFile = new FileWriter("./PhysMo.prop");
                    PrintWriter out = new PrintWriter(outFile);
           
                    // Also could be written as follows on one line
                    // Printwriter out = new PrintWriter(new FileWriter(args[0]));
       
                    // Write text to file
                    out.println(PhysMo.lastVideoDirectory);
                    out.println(PhysMo.lastWorkingDirectory);
                    out.close();
             
                    
                    
                    
                    
                    
                     f.setVisible(true);
            
           
            
            Thread t = new Thread(this);
            
            t.start();        
            synchronized(this){notifyAll();}
                    
                    
                    
                    
            }
                
                
                }
                catch(IOException ioe)
                {
                    
                }
                
                
                
                
            }
            
            
            
            
            
           
            
        }
        
        if(e.getSource()== aboutPhysmo)
        {
            try
            {
                Runtime.getRuntime().exec("acroread ./about.pdf");
            }
            catch(java.io.IOException error)
            {
                //Handle an IOException here.
                return;
            }
        }
    }
    
    public void run()
    {
                 
                        pb.setIndeterminate(true);                                                
                        pb.setString("Decomposing video");
                        pb.setStringPainted(true);
                        f.repaint();
       
       
                ffmpeg.decomposeVideo(PhysMo.videoPath, PhysMo.workingDirectory, "png");
                
                        pb.setIndeterminate(true);                                                
                        pb.setString("Opening video");
                        pb.setStringPainted(true);
                        f.repaint();
                
                
                try{
                Runnable doWorkRunnable3 = new Runnable() 
                {
                    public void run() 
                    {
                        projectWindow = new AnalysisWindow();
                         projectWindow.setVisible(true);
                        projectWindow.toFront();
                        projectWindow.setExtendedState(projectWindow.getExtendedState()|JFrame.MAXIMIZED_BOTH);
                         PhysMo.isVisible = true;
                         
                        
                    }
                };
                SwingUtilities.invokeAndWait(doWorkRunnable3);
                }
                catch(InterruptedException ie)
                {
                    
                }
                catch(InvocationTargetException iv)
                {
                    
                }
                projectWindow.addWindowListener(this);
               
                pb.setIndeterminate(false);                                                
                pb.setStringPainted(false);
                f.repaint();
                f.toBack();
                
    }
    
    public void windowOpened(WindowEvent e)
    {
        
    }
    
    public void windowClosing(WindowEvent e)
    {
        if(e.getSource() == projectWindow)
        {
            System.out.println("Window closing");
            PhysMo.isVisible = false;
            newProject.setEnabled(true);
            newProject.repaint();
        }
        
        if(e.getSource() == f)
        {
            int i = JOptionPane.showConfirmDialog(null, "This will close PhysMo! \nAre you sure?","Close PhysMo",JOptionPane.YES_NO_OPTION,JOptionPane.WARNING_MESSAGE);
            if(i == JOptionPane.YES_OPTION)
            {
                f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
            }
            else
            {
                f.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
            }
        }
        
    }
    
    public void windowClosed(WindowEvent e)
    {
        System.out.println("Window closed");
    }
    
    public void windowIconified(WindowEvent e)
    {
        
    }
    
    public void windowDeiconified(WindowEvent e)
    {
        
    }
    
    public void windowActivated(WindowEvent e)
    {
        
    }
    
    public void windowDeactivated(WindowEvent e)
    {
        
    }
    
    
}
