/*
 * This is the main window to collect all components and tools in the same location
 */
package main;

import tools.*;
import gui.images.*;
import gui.components.*;

import javax.swing.*;
import java.awt.*;
import java.awt.Event.*;
import java.io.*;


import org.pushingpixels.substance.api.*;
import org.pushingpixels.substance.api.skin.*;



/**
 *
 * @author jasonkb
 */
public class PhysMo extends JFrame
{
    public FirstScreen openScreen;
    public static String videoName = "";
    public static String videoPath = "";
    public static String workingDirectory = "";
    public static String videoInformation = "";
    public static String lastVideoDirectory = "./";
    public static String lastWorkingDirectory = "./";
    public static double duration = 0.0;
    public static double fps = 0.0;
    public static double unMagnifiedRealWorldDistance = 0.0;
    public Distributor d = new Distributor();
    public static boolean windows;
    public static String videoInformationString = "FFMPEG OUTPUT";
    
    public static boolean isVisible = false;
    
    public PhysMo()
    {
        super("PhysMo v2.0");
        super.setIconImage(d.getFrameIcon());
        openScreen = new FirstScreen(this);
        SwingUtilities.updateComponentTreeUI(openScreen);
        this.add(openScreen, BorderLayout.CENTER);
        PhysMo.windows = isWindows();
    }
    
    public static boolean isWindows(){
 
		String os = System.getProperty("os.name").toLowerCase();
		//windows
	    return (os.indexOf( "win" ) >= 0); 
 
	}
    
    
    
    
    public static void main(String args[])
    {
        try
        {
            FileInputStream fstream = new FileInputStream("PhysMo.prop");
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strline = "";
            
            //read in video folder
            strline = br.readLine();
            PhysMo.lastVideoDirectory = strline;
            System.out.println("Last video directory: "+strline);
            
            
            strline = br.readLine();
            PhysMo.lastWorkingDirectory = strline;
            System.out.println("Last working directory: "+strline);
            
            br.close();
            
            
        }
        catch(FileNotFoundException e)//file doesn't exist so create a basic one and populate the values accordingly!
        {
            
        }
        catch(IOException ioe)
        {
            
        }
        
        
        Runnable doWorkRunnable = new Runnable() 
                {
                    public void run() 
                    {
                        SubstanceSkin skin = new OfficeSilver2007Skin();
                        SubstanceLookAndFeel.setSkin(skin);
                        
                    }
                };
        SwingUtilities.invokeLater(doWorkRunnable);
        
        
        
        PhysMo f = new PhysMo();
        SwingUtilities.updateComponentTreeUI(f);
        Splash splash = new Splash(3000);

        splash.showSplashAndExit();
        
       
        
        f.pack();
        
        Dimension screen = Toolkit.getDefaultToolkit().getScreenSize();
        int x = (screen.width- 600)/2;
        int y = (screen.height - 150)/2;
        f.setBounds(x,y,600,150);
        
        
        
        f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        
        f.setVisible(true);
        
        
        
      
        
        
    
    
}
    
}
